
Ruby - Bug #10384

Fiddle::DLError: unknown symbol "Init_objspace" during Fiddle::TestHandle#test_NEXT and

Fiddle::TestHandle#test_static_sym on Solaris

10/14/2014 01:14 PM - ngoto (Naohisa Goto)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.2.0dev (2014-10-14)

[sparc64-solaris2.10]

Backport: 2.0.0: REQUIRED, 2.1: DONE, 2.2:

DONE

Description

Solarisにて、make test-all中に以下のエラーが発生することが多くなっています。

（出ないこともたまにあります。）

  2) Error:

DL::TestHandle#test_static_sym:

DL::DLError: unknown symbol "Init_objspace"

    /XXXXX/test/dl/test_handle.rb:34:in `sym'

    /XXXXX/test/dl/test_handle.rb:34:in `rescue in test_static_sym'

    /XXXXX/test/dl/test_handle.rb:27:in `test_static_sym'

  4) Error:

Fiddle::TestHandle#test_NEXT:

Fiddle::DLError: unknown symbol "Init_objspace"

    /XXXXX/test/fiddle/test_handle.rb:171:in `[]'

    /XXXXX/test/fiddle/test_handle.rb:171:in `rescue in test_NEXT'

    /XXXXX/test/fiddle/test_handle.rb:144:in `test_NEXT'

  5) Error:

Fiddle::TestHandle#test_static_sym:

Fiddle::DLError: unknown symbol "Init_objspace"

    /XXXXX/test/fiddle/test_handle.rb:41:in `sym'

    /XXXXX/test/fiddle/test_handle.rb:41:in `rescue in test_static_sym'

    /XXXXX/test/fiddle/test_handle.rb:34:in `test_static_sym'

 Fiddle::Handle.sym および Fiddle::Handle.[] （DL::Handle.sym なども同様）は内部で RTLD_NEXT を使用しています。

Solarisのman dlsym(3C) より引用します。

http://docs.oracle.com/cd/E23823_01/html/816-5168/dlsym-3c.html

     RTLD_NEXT       Instructs dlsym() to search  for  the  named

                     symbol  in the objects that were loaded fol-

                     lowing the object  from  which  the  dlsym()

                     call is being made.

 Solarisのdlsymでは、handleに RTLD_NEXT を指定した場合は、そのコードが読み込まれた後に読み込んだシンボルしか検索しません。

このため、require "objspace" による objspace.so の読み込みが require "fiddle" より前に発生していた場合はエラーになります。

（requireの順番によりエラーが出る・出ないの再現コード）

 % ruby -e 'require "objspace"; require "fiddle"; p Fiddle::Handle.sym("Init_objspace")'

-e:1:in `sym': unknown symbol "Init_objspace" (Fiddle::DLError)

        from -e:1:in `<main>'

 % ruby -e 'require "fiddle"; require "objspace"; p Fiddle::Handle.sym("Init_objspace")'

9223372034655938496

 単純にgrepすると、require "objspace" は以下で行われています。

test/dl/test_handle.rb:        require 'objspace'

test/fiddle/test_closure.rb:      require 'objspace'

test/fiddle/test_handle.rb:        require 'objspace'
test/lib/profile_test_all.rb:require 'objspace'

test/objspace/test_objspace.rb:require "objspace"

test/ruby/test_file_exhaustive.rb:    require "objspace"

これらのテストの実行順番に依存して（ファイルシステムのディレクトリエントリの順番の偶然などのタイミングによって？）、エラーが出たり出なかったりするようです。

Related issues:

Related to Ruby - Bug #9928: Fiddle::TestHandle#test_NEXT fails on AIX due to... Closed

Associated revisions

Revision 64e2406427a7126d7d04b018149b10535670ed84 - 01/05/2015 03:16 PM - nobu (Nobuyoshi Nakada)

test_handle.rb: use -test-/dln/empty

test/fiddle/test_handle.rb (test_NEXT): use -test-/dln/empty

which is always a shared object and is not used by others.

[ruby-dev:48629] [Bug #10384]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@49157 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 64e24064 - 01/05/2015 03:16 PM - nobu (Nobuyoshi Nakada)

test_handle.rb: use -test-/dln/empty

test/fiddle/test_handle.rb (test_NEXT): use -test-/dln/empty

which is always a shared object and is not used by others.

[ruby-dev:48629] [Bug #10384]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@49157 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision d8edc3e477bd0ccee0d52014cefc00b1ba2c081d - 03/30/2015 03:32 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) r49157: [Backport #10384]

    * test/fiddle/test_handle.rb (test_NEXT): use -test-/dln/empty

      which is always a shared object and is not used by others.

      [ruby-dev:48629] [Bug #10384]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@50129 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision d8edc3e4 - 03/30/2015 03:32 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) r49157: [Backport #10384]

    * test/fiddle/test_handle.rb (test_NEXT): use -test-/dln/empty

      which is always a shared object and is not used by others.

      [ruby-dev:48629] [Bug #10384]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@50129 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 976bf35c12581658f817541450cac253df3bc2d2 - 04/24/2015 08:34 AM - U.Nakamura 

merge revision(s) 49154,49155,49156,49159: [Backport #10384] [Backport #11085]

    ext/-test-/dln/empty: move from ext/-test-/win32/dln

    * test/fiddle/test_handle.rb: fix syntax.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@50383 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 976bf35c - 04/24/2015 08:34 AM - U.Nakamura 

merge revision(s) 49154,49155,49156,49159: [Backport #10384] [Backport #11085]

    ext/-test-/dln/empty: move from ext/-test-/win32/dln

    * test/fiddle/test_handle.rb: fix syntax.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@50383 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision b1a5f3e4b41bca40e921ac211b7d6784f6606cf1 - 03/28/2016 02:53 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 49157: [Backport #10384]

    * test/fiddle/test_handle.rb (test_NEXT): use -test-/dln/empty

      which is always a shared object and is not used by others.
      [ruby-dev:48629] [Bug #10384]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@54316 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision b1a5f3e4 - 03/28/2016 02:53 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 49157: [Backport #10384]

    * test/fiddle/test_handle.rb (test_NEXT): use -test-/dln/empty

      which is always a shared object and is not used by others.

      [ruby-dev:48629] [Bug #10384]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@54316 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 82752cc1ce2129c9d44515f40739a27b88218f0d - 03/28/2016 05:46 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 49154: [Backport #10384]

    ext/-test-/dln/empty: move from ext/-test-/win32/dln

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@54342 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 82752cc1 - 03/28/2016 05:46 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 49154: [Backport #10384]

    ext/-test-/dln/empty: move from ext/-test-/win32/dln

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@54342 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 01/05/2015 03:38 AM - hsbt (Hiroshi SHIBATA)

- Related to Bug #9928: Fiddle::TestHandle#test_NEXT fails on AIX due to unexported symbols of extension libraries added

#2 - 01/05/2015 03:16 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

- % Done changed from 0 to 100

Applied in changeset r49157.

test_handle.rb: use -test-/dln/empty

test/fiddle/test_handle.rb (test_NEXT): use -test-/dln/empty

which is always a shared object and is not used by others.

[ruby-dev:48629] [Bug #10384]

#3 - 01/14/2015 08:09 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.0.0: UNKNOWN, 2.1: UNKNOWN to 2.0.0: REQUIRED, 2.1: REQUIRED

#4 - 03/30/2015 03:33 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.0.0: REQUIRED, 2.1: REQUIRED to 2.0.0: REQUIRED, 2.1: DONE

Backported into ruby_2_1 at r50129.

#6 - 04/22/2015 04:57 AM - ngoto (Naohisa Goto)

- Backport changed from 2.0.0: REQUIRED, 2.1: DONE to 2.0.0: REQUIRED, 2.1: REQUIRED

#7 - 04/24/2015 08:34 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.0.0: REQUIRED, 2.1: REQUIRED to 2.0.0: REQUIRED, 2.1: DONE

ruby_2_1 r50383 merged revision(s) 49154,49155,49156,49159.

#8 - 03/28/2016 02:53 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.0.0: REQUIRED, 2.1: DONE to 2.0.0: REQUIRED, 2.1: DONE, 2.2: DONE
Backported into ruby_2_2 branch at r54316.

#9 - 03/28/2016 05:50 PM - nagachika (Tomoyuki Chikanaga)

r49154 should be backported too. Backported into ruby_2_2 branch at r54342.
